/*
    FIX 1.2
    - correction. Spec, player respawn (is_user_connected)
*/

#include <amxmodx>
#include <cstrike>
#include <hamsandwich>
#include <dhudmessage>

#pragma tabsize 0

#if AMXX_VERSION_NUM < 183
#include <fakemeta>
#endif

#define PLUGIN "Warming"
#define VERSION "1.2"
#define AUTHOR "I Am LeGenD"

/**================================================================================
	Различные данные и настройки
=================================================================================*/
#define FORMAP35HP          // Закомментируй если не хочешь чтобы в ножевом раунде у игроков было по 35 ХП
#define KNIFE_WARM         // Разминка на ножах. Закомментируй, если не хочешь чтобы была разминка на ножах.
//#define PISTOL_WARM     // Разкомментируй если хочешь, чтобы была разминка на пистолях

#define LGD 3431
#define LENGTH_THE_TEX 200 // Максимальная длина текста
#define THE_LENGTH_MAPS 40 // Максимальное количество карт в конфигурационному файле

/**================================================================================
	Константы
=================================================================================*/
new timer[33], cvar_warm
new bool:knife = false
new bool:maps_mds
new bool:drop

/**================================================================================
	Загружаем плагин
=================================================================================*/
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	new const Warm_Plugins[][] ={"warming.amxx"};
	
	register_event("TextMsg","warm_start","a","2&#Game_C")     
	
	cvar_warm = register_cvar("timer_warm","30")               // Квар таймера
	register_event("CurWeapon","weapon","be","1=1","2!29") 
	
	#if defined FORMAP35HP
	RegisterHam(Ham_Spawn, "player", "Player_Spawn", 1)   
	#endif
	register_event("DeathMsg","death_msg","a")
	
	register_clcmd("drop", "clcmd_drop")                   // Запрет дропа
	
	if(maps_start())
	{
		maps_mds = true
	}
	
	for(new i = 0; i < sizeof(Warm_Plugins); i++)
	{
	if(maps_mds && find_plugin_byfile(Warm_Plugins[i]))
		pause("acd", Warm_Plugins[i]);    // останавливаем работу плагина на определенных картах.
	}
	
	register_dictionary( "warming.txt" ) // мульти
}

/**===========================================================================================
	Загрузка кофинга.
==============================================================================================*/
maps_start(){

	new aktion, reverse, len
	new config[LENGTH_THE_TEX]
	new patsch[LENGTH_THE_TEX]
	new mapname[THE_LENGTH_MAPS]
	new text[LENGTH_THE_TEX]

	get_localinfo("amxx_configsdir", config, charsmax(config))
	get_mapname(mapname, THE_LENGTH_MAPS-1)

	format(patsch, LENGTH_THE_TEX, "%s/warm_block_map.ini", config)

	if (file_exists(patsch))
	{
		aktion = read_file(patsch, reverse, text, LENGTH_THE_TEX-1, len)
		while (aktion>0)
		{
			if (equali(text, mapname)) return 1
			reverse++
			aktion = read_file(patsch, reverse, text, LENGTH_THE_TEX-1, len)
		}
	}
	return 0
}

/**================================================================================
	Запускаем таск
=================================================================================*/
public warm_start(id){    
 
    set_task(1.0, "Start")
}

/**================================================================================
	Таск запустил таймер, и включил константы
=================================================================================*/
public Start(id){
    weapon(id)
	
    knife = true
	drop = true
	
    timer[id] = get_pcvar_num(cvar_warm);
        
    if(task_exists(id + LGD))
    {
        remove_task( id + LGD )
    }
    set_task(1.0, "timer_start", id + LGD, _, _, "b")
        
    return PLUGIN_CONTINUE
}

/**=========================================================================================
	Загружаем DHUD, выключаем таймер, делаем рестарт, перезагружаем таск, выключаем костанты
============================================================================================*/
public timer_start(task_id){
    new id = task_id - LGD
	
    set_dhudmessage(065, 105, 225, 0.03, 0.65, 2, 0.02, 1.0, 0.01, 0.1, 10)
    show_dhudmessage(id, "%L", LANG_PLAYER, "TIMER_INFO", timer[id])
        
    timer[id] -= 1 
        
    if(timer[id] <= 0)
    {
        if( task_exists(task_id) )
        {
            remove_task( task_id )
        }
			
		set_cvar_num("sv_restart", 1);
		set_task(3.0, "happy_end")
		knife = false 
		drop = false  // выключаем дроп, даем возможность дропать оружия.
	}
}

/**===========================================================================================
	Событие спауна
==============================================================================================*/
#if defined FORMAP35HP
public Player_Spawn(id){
   if(is_user_alive(id) && knife)
   {
    set_pev( id, pev_health, 35.0 ) // устанавливаем желаемое количество жизней при спауне.
   }
}
#endif

/**================================================================================
	Событие оружия
=================================================================================*/
public weapon(id){
	if (!knife)
		return PLUGIN_CONTINUE
		
	#if defined KNIFE_WARM
	engclient_cmd(id,"weapon_knife")
	#endif
	
	#if defined PISTOL_WARM
	cs_set_user_bpammo(id, CSW_GLOCK18, 100)
	cs_set_user_bpammo(id, CSW_USP, 100)
	#endif
	
	return PLUGIN_CONTINUE
}

/**================================================================================
	Событие смерти, включаем таск.
=================================================================================*/
public death_msg(){

	if(!knife)
		return
	
	new id = read_data(2)	
	set_task(1.0,"respawn",id)
}

/**===========================================================================================
	Событие респауна, игрок воскресился
==============================================================================================*/
public respawn(id){     

	if(is_user_connected(id))
		ExecuteHamB(Ham_CS_RoundRespawn, id)
}

/**================================================================================
	Вывод DHUD сообщения после рестарта.
=================================================================================*/
public happy_end(){

    set_dhudmessage( random_num(0, 255), random_num(0, 255), random_num(0, 255), 0.03, 0.65, 2, 6.0, 3.0, 0.1, 1.5, false )
    show_dhudmessage(0, "%L", LANG_PLAYER, "TIMER_FALSE")
}

/**================================================================================
	Запрещаем дропать оружия в начале разминки.
=================================================================================*/
public clcmd_drop(id){

	if(drop)
	{
 		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}